<html lang="en">
  <style>
    .container {
      margin: 40px auto;
      width: 80%;
    }
    .button {
      width: 160px;
      height: 45px;
      border-radius: 6px;
      font-size: 15px;
      margin-top: 20px;
    }
    img {
      width: 328px;
      height: 287px;
      display: block;
      margin-bottom: 20px;
    }
    hr {
      width: 400px;
      margin-left: 0;
    }
    h3 {
      display: inline-block;
    }
    #container {
      display: none;
    }
    #container-edit {
      display: none;
    }
    #container-edit li {
      margin: 10px;
    }
    #container-edit input {
      height: 32px;
      margin-left: 30px;
    }
    #container-edit input {
      width: 195px;
      font-size: 15px;
    }
  </style>
  <script>
    // HOST must be the server IP or DNS name when app running on a server
    // and localhost when running locally
    const HOST = "dockerexercise.itfellasgroup.com";

    (async function init() {
      const response = await fetch(`http://${HOST}:8080/get-data`);
      console.log("response", response);
      const data = await response.json();
      console.log("stringified data: " + JSON.stringify(data));

      let element = document.getElementById("member-roles");
      let editElement = document.getElementById("member-roles-edit");
      data.forEach((user) => {
        let li = document.createElement("li");
        let spanName = document.createElement("span");
        let spanSpace = document.createElement("span");
        let spanRole = document.createElement("span");

        spanRole.setAttribute("id", `role-${user.name}`);
        spanName.setAttribute("class", "name");
        li.setAttribute("class", "member-role");

        spanName.innerText = user.name;
        spanSpace.innerText = ": ";
        spanRole.innerText = user.role;

        li.appendChild(spanName);
        li.appendChild(spanSpace);
        li.appendChild(spanRole);
        element.appendChild(li);

        let editLi = document.createElement("li");
        let name = document.createElement("span");
        let label = document.createElement("label");
        let input = document.createElement("input");

        name.innerText = user.name;
        name.setAttribute("class", "name-edit");
        label.setAttribute("for", `input-role-${user.name}`);
        input.setAttribute("id", `input-role-${user.name}`);
        input.setAttribute("type", "text");
        editLi.setAttribute("class", "member-role-edit");

        editLi.appendChild(name);
        editLi.appendChild(label);
        editLi.appendChild(input);

        editElement.appendChild(editLi);
      });

      const cont = document.getElementById("container");
      cont.style.display = "block";
    })();

    async function handleUpdateProfileRequest() {
      const contEdit = document.getElementById("container-edit");
      const cont = document.getElementById("container");

      const payload = [];

      const els = document.getElementsByClassName("member-role-edit");
      Array.from(els).forEach((el) => {
        const name = el.getElementsByClassName("name-edit").item(0).textContent;
        const role = document.getElementById(`input-role-${name}`).value;

        payload.push({
          name: name,
          role: role,
        });
      });

      const response = await fetch(`http://${HOST}:8080/update-roles`, {
        method: "POST",
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json",
        },
        body: JSON.stringify(payload),
      });

      const jsonResponse = await response.json();

      jsonResponse.forEach((member) => {
        document.getElementById(`role-${member.name}`).textContent =
          member.role;
      });

      cont.style.display = "block";
      contEdit.style.display = "none";
    }

    function updateRole() {
      const contEdit = document.getElementById("container-edit");
      const cont = document.getElementById("container");

      const els = document.getElementsByClassName("member-role");
      Array.from(els).forEach((el) => {
        const name = el.getElementsByClassName("name").item(0).textContent;
        document.getElementById(`input-role-${name}`).value =
          document.getElementById(`role-${name}`).textContent;
      });

      cont.style.display = "none";
      contEdit.style.display = "block";
    }
  </script>
  <body>
    <div>
      <h1>Team member roles</h1>
      <img
        src="https://tlcpethospitalrc.com/wp-content/uploads/2020/04/Pups.jpg"
        alt="user-profile"
      />
    </div>

    <div class="container" id="container">
      <ul id="member-roles"></ul>
      <button class="button" onclick="updateRole()">Edit</button>
    </div>

    <div class="container" id="container-edit">
      <ul id="member-roles-edit"></ul>
      <button class="button" onclick="handleUpdateProfileRequest()">
        Save
      </button>
    </div>
  </body>
</html>
